zenilib: zenilib/jni/external/angle/src/compiler/ShaderLang.cpp File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Functions
ShaderLang.cpp File Reference
`#include "GLSLANG/ShaderLang.h"`
`#include "compiler/InitializeDll.h"`
`#include "compiler/preprocessor/length_limits.h"`
`#include "compiler/ShHandle.h"`
`#include "compiler/TranslatorHLSL.h"`

Go to the source code of this file.

## Functions

static bool | checkActiveUniformAndAttribMaxLengths (const ShHandle handle, size_t expectedValue)
static bool | checkMappedNameMaxLength (const ShHandle handle, size_t expectedValue)
static void | getVariableInfo (ShShaderInfo varType, const ShHandle handle, int index, size_t *length, int *size, ShDataType *type, char *name, char *mappedName)
int | ShCompile (const ShHandle handle, const char *const shaderStrings[], size_t numStrings, int compileOptions)
ShHandle | ShConstructCompiler (ShShaderType type, ShShaderSpec spec, ShShaderOutput output, const ShBuiltInResources *resources)
void | ShDestruct (ShHandle handle)
int | ShFinalize ()
void | ShGetActiveAttrib (const ShHandle handle, int index, size_t *length, int *size, ShDataType *type, char *name, char *mappedName)
void | ShGetActiveUniform (const ShHandle handle, int index, size_t *length, int *size, ShDataType *type, char *name, char *mappedName)
void | ShGetInfo (const ShHandle handle, ShShaderInfo pname, size_t *params)
void | ShGetInfoLog (const ShHandle handle, char *infoLog)
void | ShGetInfoPointer (const ShHandle handle, ShShaderInfo pname, void **params)
void | ShGetNameHashingEntry (const ShHandle handle, int index, char *name, char *hashedName)
void | ShGetObjectCode (const ShHandle handle, char *objCode)
void | ShInitBuiltInResources (ShBuiltInResources *resources)
int | ShInitialize ()

## Function Documentation

static bool checkActiveUniformAndAttribMaxLengths | ( | const ShHandle | handle,
|  | size_t | expectedValue
| ) |  |

static

Definition at line 24 of file ShaderLang.cpp.

References SH_ACTIVE_ATTRIBUTE_MAX_LENGTH, SH_ACTIVE_UNIFORM_MAX_LENGTH, and ShGetInfo().

Referenced by getVariableInfo().

static bool checkMappedNameMaxLength | ( | const ShHandle | handle,
|  | size_t | expectedValue
| ) |  |

static

Definition at line 34 of file ShaderLang.cpp.

References SH_MAPPED_NAME_MAX_LENGTH, and ShGetInfo().

Referenced by getVariableInfo().

static void getVariableInfo | ( | ShShaderInfo | varType,
|  | const ShHandle | handle,
|  | int | index,
|  | size_t * | length,
|  | int * | size,
|  | ShDataType * | type,
|  | char * | name,
|  | char * | mappedName
| ) |  |

static

Definition at line 41 of file ShaderLang.cpp.

References ASSERT, checkActiveUniformAndAttribMaxLengths(), checkMappedNameMaxLength(), TShHandleBase::getAsCompiler(), TCompiler::getAttribs(), TCompiler::getUniforms(), TVariableInfo::mappedName, MAX_SYMBOL_NAME_LEN, TVariableInfo::name, SH_ACTIVE_ATTRIBUTES, SH_ACTIVE_UNIFORMS, TVariableInfo::size, and TVariableInfo::type.

Referenced by ShGetActiveAttrib(), and ShGetActiveUniform().

int ShCompile | ( | const ShHandle | handle,
|  | const char *const | shaderStrings[],
|  | size_t | numStrings,
|  | int | compileOptions
| ) |  |

Definition at line 176 of file ShaderLang.cpp.

References TCompiler::compile(), and TShHandleBase::getAsCompiler().

Referenced by Zeni::Video::compile_glsles_shader(), and CompileFile().

ShHandle ShConstructCompiler | ( | ShShaderType | type,
|  | ShShaderSpec | spec,
|  | ShShaderOutput | output,
|  | const ShBuiltInResources * | resources
| ) |  |

Definition at line 140 of file ShaderLang.cpp.

References ConstructCompiler(), TShHandleBase::getAsCompiler(), TCompiler::Init(), and ShDestruct().

Referenced by Zeni::Video_GL_Shader::init(), Zeni::Video_GL_Fixed::init(), Zeni::Video_DX9::init_device(), and main().

void ShDestruct | ( | ShHandle | handle | ) |

Definition at line 158 of file ShaderLang.cpp.

References DeleteCompiler(), and TShHandleBase::getAsCompiler().

Referenced by Zeni::Video_DX9::destroy_device(), main(), ShConstructCompiler(), Zeni::Video_GL_Shader::uninit(), and Zeni::Video_GL_Fixed::uninit().

int ShFinalize | ( |  | ) |

Definition at line 100 of file ShaderLang.cpp.

References DetachProcess().

Referenced by main(), and Zeni::Video::Video().

void ShGetActiveAttrib | ( | const ShHandle | handle,
|  | int | index,
|  | size_t * | length,
|  | int * | size,
|  | ShDataType * | type,
|  | char * | name,
|  | char * | mappedName
| ) |  |

Definition at line 280 of file ShaderLang.cpp.

References getVariableInfo(), and SH_ACTIVE_ATTRIBUTES.

Referenced by PrintActiveVariables().

void ShGetActiveUniform | ( | const ShHandle | handle,
|  | int | index,
|  | size_t * | length,
|  | int * | size,
|  | ShDataType * | type,
|  | char * | name,
|  | char * | mappedName
| ) |  |

Definition at line 292 of file ShaderLang.cpp.

References getVariableInfo(), and SH_ACTIVE_UNIFORMS.

Referenced by PrintActiveVariables().

void ShGetInfo | ( | const ShHandle | handle,
|  | ShShaderInfo | pname,
|  | size_t * | params
| ) |  |

Definition at line 194 of file ShaderLang.cpp.

References TShHandleBase::getAsCompiler(), TCompiler::getAttribs(), TCompiler::getHashFunction(), TCompiler::getInfoSink(), TCompiler::getNameMap(), TCompiler::getUniforms(), HASHED_NAME_PREFIX, TInfoSink::info, MAX_SYMBOL_NAME_LEN, NULL, TInfoSink::obj, SH_ACTIVE_ATTRIBUTE_MAX_LENGTH, SH_ACTIVE_ATTRIBUTES, SH_ACTIVE_UNIFORM_MAX_LENGTH, SH_ACTIVE_UNIFORMS, SH_HASHED_NAME_MAX_LENGTH, SH_HASHED_NAMES_COUNT, SH_INFO_LOG_LENGTH, SH_MAPPED_NAME_MAX_LENGTH, SH_NAME_MAX_LENGTH, SH_OBJECT_CODE_LENGTH, TInfoSinkBase::size(), and UNREACHABLE.

Referenced by checkActiveUniformAndAttribMaxLengths(), checkMappedNameMaxLength(), Zeni::Video::compile_glsles_shader(), main(), PrintActiveVariables(), and ShGetNameHashingEntry().

void ShGetInfoLog | ( | const ShHandle | handle,
|  | char * | infoLog
| ) |  |

Definition at line 251 of file ShaderLang.cpp.

References TInfoSinkBase::c_str(), TShHandleBase::getAsCompiler(), TCompiler::getInfoSink(), and TInfoSink::info.

Referenced by main().

void ShGetInfoPointer | ( | const ShHandle | handle,
|  | ShShaderInfo | pname,
|  | void ** | params
| ) |  |

Definition at line 347 of file ShaderLang.cpp.

References TShHandleBase::getAsTranslatorHLSL(), TranslatorHLSL::getUniforms(), SH_ACTIVE_UNIFORMS_ARRAY, and UNREACHABLE.

void ShGetNameHashingEntry | ( | const ShHandle | handle,
|  | int | index,
|  | char * | name,
|  | char * | hashedName
| ) |  |

Definition at line 304 of file ShaderLang.cpp.

References ASSERT, TShHandleBase::getAsCompiler(), TCompiler::getNameMap(), i, SH_HASHED_NAME_MAX_LENGTH, SH_NAME_MAX_LENGTH, and ShGetInfo().

void ShGetObjectCode | ( | const ShHandle | handle,
|  | char * | objCode
| ) |  |

Definition at line 267 of file ShaderLang.cpp.

References TInfoSinkBase::c_str(), TShHandleBase::getAsCompiler(), TCompiler::getInfoSink(), and TInfoSink::obj.

Referenced by Zeni::Video::compile_glsles_shader(), and main().

void ShInitBuiltInResources | ( | ShBuiltInResources * | resources | ) |

Definition at line 109 of file ShaderLang.cpp.

References ShBuiltInResources::ARB_texture_rectangle, ShBuiltInResources::ArrayIndexClampingStrategy, ShBuiltInResources::EXT_draw_buffers, ShBuiltInResources::EXT_frag_depth, ShBuiltInResources::FragmentPrecisionHigh, ShBuiltInResources::HashFunction, ShBuiltInResources::MaxCombinedTextureImageUnits, ShBuiltInResources::MaxDrawBuffers, ShBuiltInResources::MaxFragmentUniformVectors, ShBuiltInResources::MaxTextureImageUnits, ShBuiltInResources::MaxVaryingVectors, ShBuiltInResources::MaxVertexAttribs, ShBuiltInResources::MaxVertexTextureImageUnits, ShBuiltInResources::MaxVertexUniformVectors, NULL, ShBuiltInResources::OES_EGL_image_external, ShBuiltInResources::OES_standard_derivatives, and SH_CLAMP_WITH_CLAMP_INTRINSIC.

Referenced by GenerateResources(), Zeni::Video_GL_Shader::init(), Zeni::Video_GL_Fixed::init(), and Zeni::Video_DX9::init_device().

int ShInitialize | ( |  | ) |

Definition at line 91 of file ShaderLang.cpp.

References InitProcess().

Referenced by main(), and Zeni::Video::Video().